/* Generated By:JJTree&JavaCC: Do not edit this line. MetaTFParserConstants.java */
/**
 *
 * Copyright (C) 2000 Richard Jones.
 *
 * Grammar for MetaTF 1.2
 *
 * Based on Grammar for Meta-TF 1.0, for which details can be found in
 * "Designing a Trace Format for Heap Allocation Events",
 * Trishul Chilimbi, Richard Jones and Benjamin Zorn,
 * ISMM 2000, Minneapolis, October 2000, ACM.
 *
 * Changes since MetaTF 1.0:
 *
 * MetaTF 1.2
 * 1. Record fields are typed. The primitive types are:
 *     byte, short, int, long, string or index.
 * 2. Only the following encodings are recognised:
 *    None, Delta, Default, BaseOffset and Stride.
 *    Strings may only have encodings None or Default.
 * 3. The syntax for defining fields is changed. For example,
 *        int foo = Default 3;
 * 4. Only single line comments starting with a # are allowed.
 *
 * MetaTF 1.1
 * 1. Removed RHS of property in the form "field.property"
 * 2. Removed anonymous tuples, e.g. rec : (a, b, (x, y), c)
 *    These must now be written as either
 *	rec : (a, b, x, y, z)
 *    or
 *	xy : (x, y)
 *	rec: (a, b, xy, c)
 * 3. In repeated events, such as a * b, clarify that
 *    a is a new field, not a reference to an existing one.
 */

// $Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/MetaTFParserConstants.java,v 1.4 2001/03/29 15:53:18 rej Exp $

package MetaTF.Parser;

public interface MetaTFParserConstants {

  int EOF = 0;
  int SINGLE_LINE_COMMENT = 7;
  int INONE = 9;
  int IBASEOFFSET = 10;
  int IDELTA = 11;
  int IDEFAULT = 12;
  int ISECTIONOFFSET = 13;
  int ISTRIDE = 14;
  int ISECTIONSTRIDE = 15;
  int SECTION = 16;
  int CACHED = 17;
  int DECIMAL_LITERAL = 18;
  int HEX_LITERAL = 19;
  int STRING_LITERAL = 20;
  int IDENTIFIER = 21;
  int LETTER = 22;
  int DIGIT = 23;

  int DEFAULT = 0;
  int IN_SINGLE_LINE_COMMENT = 1;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "\"\\f\"",
    "\"#\"",
    "<SINGLE_LINE_COMMENT>",
    "<token of kind 8>",
    "\"none\"",
    "\"baseOffset\"",
    "\"delta\"",
    "\"default\"",
    "\"sectionOffset\"",
    "\"stride\"",
    "\"sectionStride\"",
    "\"section\"",
    "\"cached\"",
    "<DECIMAL_LITERAL>",
    "<HEX_LITERAL>",
    "<STRING_LITERAL>",
    "<IDENTIFIER>",
    "<LETTER>",
    "<DIGIT>",
    "\"{\"",
    "\"}\"",
    "\":\"",
    "\"*\"",
    "\"(\"",
    "\",\"",
    "\")\"",
    "\".\"",
    "\"=\"",
    "\";\"",
  };

}
