
/*
    $File$
    Date        Author          Changes
    Nov 21 2000 Richard Jones   Created

    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */
 
package MetaTF.Parser;

/**
 * Exception thrown by fields that don't contain a tag as their
 * leftmost, outermost component
 * This exception need not be fatal.
 *
 * @see <a href="metatf.jjt">The MetaTF Grammar</a>
 * @version rel-1-2 ($Revision: 1.3 $, $Date: 2000/12/15 16:29:55 $),
 * @author Richard Jones
**/
public class NoTagException extends Exception {
  private static final String cvsheader = "$Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/NoTagException.java,v 1.3 2000/12/15 16:29:55 rej Exp $";

	/**
	 * Allocate a new object representing the exception
	 *
	 * @param e an informative message
	**/
	public NoTagException(String e) { super("No tag: "+e); }
}
